<?php
/********************************* PHP-P10 ******************************
 *    P10 uplink class by pk910   (c)2011 pk910                         *
 ************************************************************************
 *                          Version 2 (OOP)                             *
 *                                                                      *
 * PHP-P10 is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with PHP-P10; if not, write to the Free Software Foundation,   *
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.       *
 *                                                                      *
 ************************************************************************
 * 
 *  Bots/PHPGod.class.php
 *
 * simple PHP debugger...
 *
 */

class {$_NAME} extends Bot {
	private $uplink;
	private $php, $phpcache = array();
	
	public function load($uplink, $old = false) {
		$this->uplink = $uplink;
		if(!$old) {
			$nick = "PHP";
			$ident = "php";
			$host = "Services.WebGamesNet.net";
			$ip = "0::0";
			$realname = "PHP PHP PHP PHP PHP";
			$modes = "ioknISD";
			$this->php = $this->uplink->addUser($nick,$ident,$host,$ip,$modes,$realname);
			if(is_a($this->php, "P10_User")) {
				$this->uplink->join($this->php, "#php", (P10_Channel::USERPRIV_OPED | P10_Channel::USERPRIV_VOICE));
				$this->uplink->join($this->php, "#dev", P10_Channel::USERPRIV_VOICE);
			}
		} else {
			$this->php = $old;
		}
		
		ModCMD::bind($this, BIND_CHANMSG, "recive_privmsg");
		ModCMD::bind($this, BIND_QUIT, "recive_quit");
	}
	
	public function unload($rehash = false) {
		foreach($this->phpcache as $id => $php) {
			fclose($php['pipes'][1]);
			fclose($php['pipes'][2]);
			proc_terminate($php['proc'],9);
		}
		$this->phpcache = array();
		if($rehash) {
			return $this->php;
		} else {
			$this->uplink->delUser($this->php, "Bye.");
		}
	}
	
	public function loop() {
		foreach($this->phpcache as $id => $php) {
			if(!$this->checkstate($php)) {
				unset($this->phpcache[$id]);
			}
		}
	}
	
	function recive_privmsg($user, $channel, $message) {
		$opOnPHPChannel = false;
		$PHPChannel = P10_Channel::getChannelByName("#PHP");
		if($PHPChannel) {
			$privs = $PHPChannel->getUserPrivs($user);
			$opOnPHPChannel = ($privs & P10_Channel::USERPRIV_OPED);
		}
		if(!$user->getModes()->hasMode('o') && !$opOnPHPChannel) return 0;
		$exp=explode(" ", $message, 2);
		switch (strtolower($exp[0])) {
			case "~php":
				if(count($this->phpcache) > 5) {
					$this->uplink->notice($this->php, $user, "too many running php processes at the moment!");
					return;
				}
				$entry=array();
				$entry['channel'] = $channel;
				$descriptor = array(0 => array("pipe", "r"),1 => array("pipe", "w"),2 => array("pipe", "w"));
				$entry['proc'] = proc_open('php', $descriptor, $entry['pipes']);
				if(!is_resource($entry['proc'])) {
					$this->uplink->notice($this->php, $user, "error while loading php!");
					return;
				}
				$entry['time'] = time();
				fwrite($entry['pipes'][0], "<"."?php ".$exp[1]." ?".">");
				fclose($entry['pipes'][0]);
				$this->phpcache[] = $entry;
				break;
		}
	}
	
	function recive_quit($user, $reason) {
		if($user === $this->php) {
			$this->load($this->uplink);
		}
	}
	
	function checkstate($php) {
		$data = proc_get_status($php['proc']);
		if(!$data['running']) {
			$out="";
			while(!feof($php['pipes'][1])) {
				$out .= fgets($php['pipes'][1], 128);
			}
			$eout="";
			while(!feof($php['pipes'][2])) {
				$eout .= fgets($php['pipes'][2], 128);
			}
			if($out != "") {
				$out=str_replace("\r","",$out);
				$lines=explode("\n",$out);
				$i=0;
				foreach($lines as $line) {
					$i++;
					if($i>1000) {
						$this->uplink->privmsg($this->php, $php['channel'], "too many lines!");
						break; 
					}
					$this->uplink->privmsg($this->php, $php['channel'], $line);
				}
			}
			if($eout != "") {
				$eout=str_replace("\r","",$eout);
				$lines=explode("\n",$eout);
				$i=0;
				foreach($lines as $line) {
					$i++;
					if($i>1000) { 
						$this->uplink->privmsg($this->php, $php['channel'], "too many lines!");
						break; 
					}
					$this->uplink->privmsg($this->php, $php['channel'], "4".$line."");
				}
			}
			fclose($php['pipes'][1]);
			fclose($php['pipes'][2]);
			proc_close($php['proc']);
			return false;
		} else {
			if($php['time']+10 > time()) {
				return true;
			} else {
				//TIMEOUT
				if($php['term']) {
					fclose($php['pipes'][1]);
					fclose($php['pipes'][2]);
					proc_terminate($php['proc'],9);
					$this->uplink->privmsg($this->php, $php['channel'], "php hard timeout. sending SIGKILL");
					return false;
				} else {
					proc_terminate($php['proc']);
					$php['term']=true;
					$this->uplink->privmsg($this->php, $php['channel'], "php timeout. (maximum of 10 seconds exceeded)  sending SIGTERM"); 
					return true;
				}
			}
		}
	}
	
}

?>